#include "24l01.h"
#include "delay.h"


    
const u8 TX_ADDRESS[TX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ
const u8 RX_ADDRESS[RX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01};

//ʼ24L01IO
void NRF24L01_Init(void)
{ 	
	GPIO_InitTypeDef GPIO_InitStructure;
  SPI_InitTypeDef  SPI_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB|RCC_APB2Periph_SPI1, ENABLE);	 //ʹʱ			

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;	//CSN 	  
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IOٶΪ50MHz
	GPIO_Init(GPIOA, &GPIO_InitStructure);					 //趨ʼGPIO
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;	//CE 
	GPIO_Init(GPIOB, &GPIO_InitStructure);					 //趨ʼGPIO
  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;  //IRQ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD; //PB0   
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	GPIO_ResetBits(GPIOB,GPIO_Pin_0|GPIO_Pin_1);//õ				 
	GPIO_ResetBits(GPIOA,GPIO_Pin_4);//õ	
	
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //PA5/6/7 
	GPIO_Init(GPIOA, &GPIO_InitStructure);//ʼGPIOA

 	GPIO_SetBits(GPIOB,GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15);  //ø

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPI
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//ͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;		//ʱյ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;	//ݲڵ1ʱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		//NSSź
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_32;		//岨ԤƵֵ:ԤƵֵΪ16
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;	//CRCֵĶʽ
	SPI_Init(SPI1, &SPI_InitStructure);  //SPI_InitStructָĲʼSPIxĴ
 
	SPI_Cmd(SPI1, ENABLE); //ʹSPI
	
	SPI1_ReadWriteByte(0xff);//
	
	NRF24L01_CE=0; 			//ʹ24L01
	NRF24L01_CSN=1;			//SPIƬѡȡ  
	 		 	 
}


//SPI ٶú
//SpeedSet:
//SPI_BaudRatePrescaler_2   2Ƶ   
//SPI_BaudRatePrescaler_8   8Ƶ   
//SPI_BaudRatePrescaler_16  16Ƶ  
//SPI_BaudRatePrescaler_256 256Ƶ 
  
void SPI1_SetSpeed(u8 SPI_BaudRatePrescaler)
{
  	assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
	SPI1->CR1&=0XFFC7;
	SPI1->CR1|=SPI_BaudRatePrescaler;	//SPI1ٶ 
	SPI_Cmd(SPI1,ENABLE); 

} 

//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI1_ReadWriteByte(u8 TxData)
{		
	u8 retry=0;				 	
	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}			  
	SPI_I2S_SendData(SPI1, TxData); //ͨSPIxһ
	retry=0;

	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)//ָSPI־λ:ܻǿձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}	  						    
	return SPI_I2S_ReceiveData(SPI1); //ͨSPIxյ					    
}


//24L01Ƿ
//ֵ:0ɹ;1ʧ	
u8 NRF24L01_Check(void)
{
	u8 buf[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
	u8 i;
	SPI1_SetSpeed(SPI_BaudRatePrescaler_8); //spiٶΪ9Mhz24L01SPIʱΪ10Mhz   	 
	NRF24L01_Write_Buf(NRF_WRITE_REG+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	NRF24L01_Read_Buf(TX_ADDR,buf,5); //дĵַ  
	for(i=0;i<5;i++)if(buf[i]!=0XA5)break;	 							   
	if(i!=5)return 1;//24L01	
	return 0;		 //⵽24L01
}	 	 
//SPIдĴ
//reg:ָĴַ
//value:дֵ
u8 NRF24L01_Write_Reg(u8 reg,u8 value)
{
	u8 status;	
   	NRF24L01_CSN=0;                 //ʹSPI
  	status =SPI1_ReadWriteByte(reg);//ͼĴ 
  	SPI1_ReadWriteByte(value);      //дĴֵ
  	NRF24L01_CSN=1;                 //ֹSPI	   
  	return(status);       			//״ֵ̬
}
//ȡSPIĴֵ
//reg:ҪļĴ
u8 NRF24L01_Read_Reg(u8 reg)
{
	u8 reg_val;	    
 	NRF24L01_CSN = 0;          //ʹSPI		
  	SPI1_ReadWriteByte(reg);   //ͼĴ
  	reg_val=SPI1_ReadWriteByte(0XFF);//ȡĴ
  	NRF24L01_CSN = 1;          //ֹSPI		    
  	return(reg_val);           //״ֵ̬
}	
//ָλöָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ 
u8 NRF24L01_Read_Buf(u8 reg,u8 *pBuf,u8 len)
{
	u8 status,u8_ctr;	       
  	NRF24L01_CSN = 0;           //ʹSPI
  	status=SPI1_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬   	   
 	for(u8_ctr=0;u8_ctr<len;u8_ctr++)pBuf[u8_ctr]=SPI1_ReadWriteByte(0XFF);//
  	NRF24L01_CSN=1;       //رSPI
  	return status;        //ض״ֵ̬
}
//ָλдָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ
u8 NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 len)
{
	u8 status,u8_ctr;	    
 	NRF24L01_CSN = 0;          //ʹSPI
  	status = SPI1_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬
  	for(u8_ctr=0; u8_ctr<len; u8_ctr++)SPI1_ReadWriteByte(*pBuf++); //д	 
  	NRF24L01_CSN = 1;       //رSPI
  	return status;          //ض״ֵ̬
}				   
//NRF24L01һ
//txbuf:׵ַ
//ֵ:״
u8 NRF24L01_TxPacket(u8 *txbuf)
{
	u8 sta;
 	SPI1_SetSpeed(SPI_BaudRatePrescaler_8);//spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	NRF24L01_CE=0;
  	NRF24L01_Write_Buf(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ
 	NRF24L01_CE=1;//	   
	while(NRF24L01_IRQ!=0);//ȴ
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ	   
	NRF24L01_Write_Reg(NRF_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_TX)//ﵽط
	{
		NRF24L01_Write_Reg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
	}
	if(sta&TX_OK)//
	{
		return TX_OK;
	}
	return 0xff;//ԭʧ
}
//NRF24L01һ
//txbuf:׵ַ
//ֵ:0ɣ
u8 NRF24L01_RxPacket(u8 *rxbuf)
{
	u8 sta;		    							   
	SPI1_SetSpeed(SPI_BaudRatePrescaler_8); //spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ    	 
	NRF24L01_Write_Reg(NRF_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&RX_OK)//յ
	{
		NRF24L01_Read_Buf(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
		NRF24L01_Write_Reg(FLUSH_RX,0xff);//RX FIFOĴ 
		return 0; 
	}	   
	return 1;//ûյκ
}					    
//úʼNRF24L01RXģʽ
//RXַ,дRXݿ,ѡRFƵ,ʺLNA HCURR
//CEߺ,RXģʽ,Խ		   
void NRF24L01_RX_Mode(void)
{
	NRF24L01_CE=0;	  
  	NRF24L01_Write_Buf(NRF_WRITE_REG+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ
	  
  	NRF24L01_Write_Reg(NRF_WRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    
  	NRF24L01_Write_Reg(NRF_WRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ  	 
  	NRF24L01_Write_Reg(NRF_WRITE_REG+RF_CH,70);	     //RFͨƵ		  
  	NRF24L01_Write_Reg(NRF_WRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 	    
  	NRF24L01_Write_Reg(NRF_WRITE_REG+RF_SETUP,0x0f);//TX,0db,2Mbps,濪   
  	NRF24L01_Write_Reg(NRF_WRITE_REG+CONFIG, 0x0f);//ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 
  	NRF24L01_CE = 1; //CEΪ,ģʽ 
}						 
//úʼNRF24L01TXģʽ
//TXַ,дTXݿ,RXԶӦĵַ,TX,ѡRFƵ,ʺLNA HCURR
//PWR_UP,CRCʹ
//CEߺ,RXģʽ,Խ		   
//CEΪߴ10us,.	 
void NRF24L01_TX_Mode(void)
{														 
	NRF24L01_CE=0;	    
  	NRF24L01_Write_Buf(NRF_WRITE_REG+TX_ADDR,(u8*)TX_ADDRESS,TX_ADR_WIDTH);//дTXڵַ 
  	NRF24L01_Write_Buf(NRF_WRITE_REG+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK	  

  	NRF24L01_Write_Reg(NRF_WRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    
  	NRF24L01_Write_Reg(NRF_WRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  
  	NRF24L01_Write_Reg(NRF_WRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10
  	NRF24L01_Write_Reg(NRF_WRITE_REG+RF_CH,70);       //RFͨΪ40
  	NRF24L01_Write_Reg(NRF_WRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
  	NRF24L01_Write_Reg(NRF_WRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж
	NRF24L01_CE=1;//CEΪ,10us
}




